local barbackdrop = {edgeFile = "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 12}
-- Create table to store the chi bar frames
MHchibar = {}

MHchibar.mainframe = CreateFrame("Frame", "MHChiBar_MainFrame", UIParent)

-- Set properties for the main frame
MHchibar.mainframe:SetWidth(160)
MHchibar.mainframe:SetHeight(32)
MHchibar.mainframe:SetPoint("CENTER", UIParent, "CENTER")

-- Create frames to use for timer functions
MHdelay = CreateFrame("Frame", "MHDelay", UIParent) -- Universal delay frame
MHtftdelay = CreateFrame("Frame", "MHtftDelay", UIParent) -- Thunder Focus Tea delay (off the gcd)
MHtptimer = CreateFrame("Frame", "MHtpTimer", UIParent) -- Tiger Power tracker timer
MHbttimer = CreateFrame("Frame", "MHbtTimer", UIParent) -- Brew tracker timer
MHbtdelay = CreateFrame("Frame", "MHbtDelay", UIParent) -- Brew tracker delay (triggers passively)
MHpduration = CreateFrame("Frame", "MHpDuration", UIParent) -- Paralysis tracker duration timer
MHdetoxcheck = CreateFrame("Frame", "MHDetoxCheck", UIParent) -- Timer to check if detox cooldown is reset
MHpmdelay = CreateFrame("Frame", "MHMPDelay", UIParent) -- To delay code for paralysis expire
MHdelay:Hide()
MHtftdelay:Hide()
MHtptimer:Hide()
MHbttimer:Hide()
MHbtdelay:Hide()
MHpduration:Hide()
MHdetoxcheck:Hide()
MHpmdelay:Hide()

-- Create event frame to handle major events
MHeventframe = CreateFrame("Frame", "MHEventFrame", UIParent)

-- Register for required events
MHeventframe:RegisterEvent("PLAYER_REGEN_ENABLED")
MHeventframe:RegisterEvent("PLAYER_REGEN_DISABLED")
MHeventframe:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
MHeventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
MHeventframe:RegisterEvent("PLAYER_SPECIALIZATION_CHANGED")
MHeventframe:RegisterEvent("PLAYER_TALENT_UPDATE")
MHeventframe:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
MHeventframe:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
MHeventframe:RegisterEvent("ADDON_LOADED")
MHeventframe:RegisterEvent("UNIT_HEALTH")
MHeventframe:RegisterEvent("UNIT_POWER_FREQUENT")
MHeventframe:RegisterEvent("UNIT_AURA")

-- Create Rising Sun Kick Icon
MHrisingsunkick = CreateFrame("Frame", "MHRisingSunKick_MainFrame", UIParent)
MHrisingsunkick:SetWidth(32)
MHrisingsunkick:SetHeight(32)
MHrisingsunkick:SetPoint("CENTER", UIParent, "CENTER")
rskicon = MHrisingsunkick:CreateTexture("RisingSunKickIcon")
rskicon:SetTexture("Interface\\Icons\\ability_monk_risingsunkick")
rskicon:SetAllPoints(MHrisingsunkick)
rskicon:SetDrawLayer("BACKGROUND")
CreateFrame("Cooldown", "MHRSKCD", MHrisingsunkick)
MHRSKCD:SetAllPoints(true)

-- Create Tiger Power Icon
MHtigerpower = CreateFrame("Frame", "MHTigerPower_MainFrame", UIParent)
MHtigerpower:SetWidth(32)
MHtigerpower:SetHeight(32)
MHtigerpower:SetPoint("CENTER", UIParent, "CENTER")
tpicon = MHtigerpower:CreateTexture("TigerPowerIcon")
tpicon:SetTexture("Interface\\Icons\\ability_monk_tigerpalm")
tpicon:SetAllPoints(MHtigerpower)
tptext = MHtigerpower:CreateFontString("MHTigerPowerText", "OVERLAY", "GameFontNormal")
tptext:SetPoint("CENTER", MHtigerpower, "BOTTOM", 0, -6)

-- create Brew Tracker
MHbrewtracker = CreateFrame("Frame", "MHBrewTracker_MainFrame", UIParent)
MHbrewtracker:SetWidth(32)
MHbrewtracker:SetHeight(32)
MHbrewtracker:SetPoint("CENTER", UIParent, "CENTER")
bticon = MHbrewtracker:CreateTexture("BrewTrackerIcon")
bticon:SetAllPoints(MHbrewtracker)
bttext = MHbrewtracker:CreateFontString("MHBrewTrackerText", "OVERLAY", "GameFontNormal")
bttext:SetPoint("CENTER", MHbrewtracker, "BOTTOM", 0, -6)
btctext = MHbrewtracker:CreateFontString("MHBrewTrackerCountText", "OVERLAY", "GameFontNormal")
btctext:SetPoint("BOTTOMRIGHT", MHbrewtracker, "BOTTOMRIGHT", -3, 3)
btctext:SetTextHeight(13)
btctext:SetTextColor(1, 1, 1)
CreateFrame("Cooldown", "MHBTCD", MHbrewtracker)
MHBTCD:SetAllPoints(true)

-- create Renewing Mist Icon
MHrenewingmist = CreateFrame("Frame", "MHRenewingMist_MainFrame", UIParent)
MHrenewingmist:SetWidth(32)
MHrenewingmist:SetHeight(32)
MHrenewingmist:SetPoint("CENTER", UIParent, "CENTER")
rmicon = MHrenewingmist:CreateTexture("RenewingMistIcon")
rmicon:SetTexture("Interface\\Icons\\ability_monk_renewingmists")
rmicon:SetAllPoints(MHrenewingmist)
CreateFrame("Cooldown", "MHRMCD", MHrenewingmist)
MHRMCD:SetAllPoints(true)


-- create Keg Smash icon
MHkegsmash = CreateFrame("Frame", "MHKegSmash_MainFrame", UIParent)
MHkegsmash:SetWidth(32)
MHkegsmash:SetHeight(32)
MHkegsmash:SetPoint("CENTER", UIParent, "CENTER")
ksicon = MHkegsmash:CreateTexture("KegSmashIcon")
ksicon:SetTexture("Interface\\Icons\\achievement_brewery_2")
ksicon:SetAllPoints(MHkegsmash)
CreateFrame("Cooldown", "MHKSCD", MHkegsmash)
MHKSCD:SetAllPoints(true)


-- create Thunder Focus Tea icon
MHthunderfocustea = CreateFrame("Frame", "MHThunderFocusTea_MainFrame", UIParent)
MHthunderfocustea:SetWidth(32)
MHthunderfocustea:SetHeight(32)
MHthunderfocustea:SetPoint("CENTER", UIParent, "CENTER")
tfticon = MHthunderfocustea:CreateTexture("ThunderFocusTeaIcon")
tfticon:SetTexture("Interface\\Icons\\ability_monk_thunderfocustea")
tfticon:SetAllPoints(MHthunderfocustea)
CreateFrame("Cooldown", "MHTFTCD", MHthunderfocustea)
MHTFTCD:SetAllPoints(true)


-- create Fists of Fury icon
MHfistsoffury = CreateFrame("Frame", "MHFistsOfFury_MainFrame", UIParent)
MHfistsoffury:SetWidth(32)
MHfistsoffury:SetHeight(32)
MHfistsoffury:SetPoint("CENTER", UIParent, "CENTER")
foficon = MHfistsoffury:CreateTexture("FistsOfFuryIcon")
foficon:SetTexture("Interface\\Icons\\monk_ability_fistoffury")
foficon:SetAllPoints(MHfistsoffury)
CreateFrame("Cooldown", "MHFOFCD", MHfistsoffury)
MHFOFCD:SetAllPoints(true)


-- create Guard icon
MHguard = CreateFrame("Frame", "MHGuard_MainFrame", UIParent)
MHguard:SetWidth(32)
MHguard:SetHeight(32)
MHguard:SetPoint("CENTER", UIParent, "CENTER")
gicon = MHguard:CreateTexture("GuardIcon")
gicon:SetTexture("Interface\\Icons\\ability_monk_guard")
gicon:SetAllPoints(MHguard)
CreateFrame("Cooldown", "MHGCD", MHguard)
MHGCD:SetAllPoints(true)


-- create Expel Harm icon
MHexpelharm = CreateFrame("Frame", "MHExpelHarm_MainFrame", UIParent)
MHexpelharm:SetWidth(32)
MHexpelharm:SetHeight(32)
MHexpelharm:SetPoint("CENTER", UIParent, "CENTER")
ehicon = MHexpelharm:CreateTexture("ExpelHarmIcon")
ehicon:SetTexture("Interface\\Icons\\ability_monk_expelharm")
ehicon:SetAllPoints(MHexpelharm)
CreateFrame("Cooldown", "MHEHCD", MHexpelharm)
MHEHCD:SetAllPoints(true)

-- create Tier 2 talent tracker
MHtier2 = CreateFrame("Frame", "MHTier2_MainFrame", UIParent)
MHtier2:SetWidth(32)
MHtier2:SetHeight(32)
MHtier2:SetPoint("CENTER", UIParent, "CENTER")
t2icon = MHtier2:CreateTexture("Tier2Icon")
t2icon:SetAllPoints(MHtier2)
CreateFrame("Cooldown", "MHT2CD", MHtier2)
MHT2CD:SetAllPoints(true)

-- create Detox icon
MHdetox = CreateFrame("Frame", "MHDetox_MainFrame", UIParent)
MHdetox:SetWidth(32)
MHdetox:SetHeight(32)
MHdetox:SetPoint("CENTER", UIParent, "CENTER")
dicon = MHdetox:CreateTexture("DetoxIcon")
dicon:SetTexture("Interface\\Icons\\Spell_Holy_DispelMagic")
dicon:SetAllPoints(MHdetox)
CreateFrame("Cooldown", "MHDCD", MHdetox)
MHDCD:SetAllPoints(true)


-- create Resource Bar
MHresourcebar = CreateFrame("StatusBar", "MHResourceBar", UIParent)
MHresourcebar:SetWidth(100)
MHresourcebar:SetHeight(12)
MHresourcebar:SetPoint("CENTER", UIParent, "CENTER")
MHresourcebar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MHresourcebarbg = CreateFrame("Frame", "MHResourceBarBG", MHresourcebar)
MHresourcebarbg:SetWidth(106)
MHresourcebarbg:SetHeight(16)
MHresourcebarbg:SetPoint("CENTER", MHresourcebar, "CENTER")
MHresourcebarbg:SetBackdrop(barbackdrop)
MHresourcebarbg:SetBackdropBorderColor(0.5, 0.5, 0.5)
rbtext = MHresourcebar:CreateFontString("RBText", "OVERLAY", "GameFontNormal")
rbtext:SetPoint("CENTER", MHresourcebar, "CENTER")
rbtext:SetTextColor(1, 1, 1)
rbtext:SetTextHeight(12)

-- Create Paralysis Timer
MHparalysis = CreateFrame("Frame", "MHParalysis", UIParent)
MHparalysis:SetWidth(32)
MHparalysis:SetHeight(32)
MHparalysis:SetPoint("CENTER", UIParent, "CENTER")
picon = MHparalysis:CreateTexture("ParalysisIcon")
picon:SetTexture("Interface\\Icons\\ability_monk_paralysis")
picon:SetAllPoints(MHparalysis)
ptext = MHparalysis:CreateFontString("MHParalysisText", "OVERLAY", "GameFontNormal")
ptext:SetPoint("CENTER", MHparalysis, "TOP", 0, 8)
CreateFrame("Cooldown", "MHPCD", MHparalysis)
MHPCD:SetAllPoints(true)

-- create Paralysis monitor
MHpmonitor = CreateFrame("StatusBar", "MHpMonitor", MHparalysis)
MHpmonitor:SetWidth(100)
MHpmonitor:SetHeight(10)
MHpmonitor:SetPoint("BOTTOMLEFT", MHparalysis, "BOTTOMRIGHT", 1, 0)
MHpmonitor:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
MHpmonitor:SetStatusBarColor(0.5, 0.3, 1)
pmtext = MHpmonitor:CreateFontString("PMText", "OVERLAY", "GameFontNormal")
pmtext:SetPoint("CENTER", MHpmonitor, "CENTER")
pmtext:SetTextColor(1, 1, 1)
pmntext = MHpmonitor:CreateFontString("PMNText", "OVERLAY", "GameFontNormal")
pmntext:SetPoint("CENTER", MHpmonitor, "CENTER", 0, 20)
MHpmonitorbg = MHparalysis:CreateTexture("MHPMBG", "BACKGROUND")
MHpmonitorbg:SetPoint("TOPLEFT", MHparalysis, "TOPLEFT", -3, 3)
MHpmonitorbg:SetHeight(38)
MHpmonitorbg:SetWidth(138)
MHpmonitorbg:SetTexture(0, 0, 0, 0.8)
MHpmonitorbg:Hide()
MHpmonitor:Hide()


function MonkHelper_CreateUI()
MHchibar.chibubble = {}
MHchibar.texture0 = {} -- Texture for empty chi
MHchibar.texture1 = {} -- Texture for full chi
-- Create the frames that will show current chi
for idx = 1, 5 do
MHchibar.chibubble[idx] = CreateFrame("Frame", "$parent_ChiBubble"..idx, MHchibar.mainframe)
end
-- Set sub frame properties
for idx = 1, 5 do
MHchibar.chibubble[idx]:SetWidth(32)
MHchibar.chibubble[idx]:SetHeight(32)
if idx == 1 then
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.mainframe, "TOPLEFT")
else
MHchibar.chibubble[idx]:SetPoint("TOPLEFT", MHchibar.chibubble[idx-1], "TOPRIGHT", -8, 0)
end
end
-- Create textures for empty/full chi bubbles
for idx = 1, 5 do
MHchibar.texture0[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture0"..idx)
MHchibar.texture1[idx] = MHchibar.chibubble[idx]:CreateTexture("Texture1"..idx)
end
-- Set texture properties
for idx = 1, 5 do
MHchibar.texture0[idx]:SetDrawLayer("ARTWORK", 6)
MHchibar.texture1[idx]:SetDrawLayer("ARTWORK", 7)
MHchibar.texture0[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture1[idx]:SetAllPoints(MHchibar.chibubble[idx])
MHchibar.texture0[idx]:SetTexture("Interface\\Playerframe\\monknopower")
MHchibar.texture1[idx]:SetTexture("Interface\\Playerframe\\monklightpower")
MHchibar.texture1[idx]:Hide()
end
if UnitPowerMax("player", 12) == 4 then
MHchibar.texture0[5]:Hide()
end
MonkHelper_SetupFrame(MHparalysis)
MonkHelper_SetupFrame(MHchibar.mainframe)
MonkHelper_SetupFrame(MHrisingsunkick)
MonkHelper_SetupFrame(MHtigerpower)
MonkHelper_SetupFrame(MHkegsmash)
MonkHelper_SetupFrame(MHrenewingmist)
MonkHelper_SetupFrame(MHthunderfocustea)
MonkHelper_SetupFrame(MHexpelharm)
MonkHelper_SetupFrame(MHtier2)
MonkHelper_SetupFrame(MHfistsoffury)
MonkHelper_SetupFrame(MHdetox)
MonkHelper_SetupFrame(MHguard)
MonkHelper_SetupFrame(MHbrewtracker)
MonkHelper_SetupFrame(MHresourcebar)
end

function MonkHelper_SetupFrame(frame)
frame:SetFrameStrata("MEDIUM")
frame:SetToplevel()
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:RegisterForDrag("LeftButton")
frame:EnableMouse(true)
frame:SetMovable(true)
end

function MonkHelper_Checked(arg) -- converts nil(unchecked) or 1(checked)  to true or false
if arg == 1 then
return false
else
return true
end
end

function MonkHelper_LockFrames()
MHchibar.mainframe:StopMovingOrSizing()
MHchibar.mainframe:EnableMouse(false)
MHresourcebar:StopMovingOrSizing()
MHresourcebar:EnableMouse(false)
MHparalysis:StopMovingOrSizing()
MHparalysis:EnableMouse(false)
MHrisingsunkick:StopMovingOrSizing()
MHrisingsunkick:EnableMouse(false)
MHtigerpower:StopMovingOrSizing()
MHtigerpower:EnableMouse(false)
MHbrewtracker:StopMovingOrSizing()
MHbrewtracker:EnableMouse(false)
MHkegsmash:StopMovingOrSizing()
MHkegsmash:EnableMouse(false)
MHrenewingmist:StopMovingOrSizing()
MHrenewingmist:EnableMouse(false)
MHthunderfocustea:StopMovingOrSizing()
MHthunderfocustea:EnableMouse(false)
MHexpelharm:StopMovingOrSizing()
MHexpelharm:EnableMouse(false)
MHtier2:StopMovingOrSizing()
MHtier2:EnableMouse(false)
MHfistsoffury:StopMovingOrSizing()
MHfistsoffury:EnableMouse(false)
MHguard:StopMovingOrSizing()
MHguard:EnableMouse(false)
MHdetox:StopMovingOrSizing()
MHdetox:EnableMouse(false)

end

function MonkHelper_UnlockFrames()
MHchibar.mainframe:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHresourcebar:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHparalysis:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHrisingsunkick:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtigerpower:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHbrewtracker:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHkegsmash:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHrenewingmist:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHthunderfocustea:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHexpelharm:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHtier2:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHfistsoffury:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHguard:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))
MHdetox:EnableMouse(MonkHelper_Checked(MonkHelper_Options.lockframes))

end

function MonkHelper_Hide()
MHchibar.mainframe:Hide()
MHresourcebar:Hide()
MHparalysis:Hide()
MHkegsmash:Hide()
MHbrewtracker:Hide()
MHtigerpower:Hide()
MHrenewingmist:Hide()
MHthunderfocustea:Hide()
MHrisingsunkick:Hide()
MHfistsoffury:Hide()
MHguard:Hide()
MHdetox:Hide()
MHexpelharm:Hide()
MHtier2:Hide()
end

function MonkHelper_Show(frame)
if MonkHelper_Options.show[frame] == 1 then
frame:Show()
elseif MonkHelper_Options.show[frame] == 0 or nil then
frame:Hide()
end
end

function MonkHelper_Show(frame, value)
if value == 1 then
frame:Show()
else 
frame:Hide()
end
end

